<?php

/**
 * liquidacion actions.
 *
 * @package    nomina
 * @subpackage liquidacion
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class liquidacionActions extends sfActions {

    /**
     * Liquidacion de la nomina
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------* Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        $records = array();
        $arrayConstantes = array();
        /*
         * Variable para optimizar consultas de formulas en las liquidaciones - 20140117
         */
        $vals_calc = array();

        /**
         * Abrir nueva conexion con la Base de Datos
         */
        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();

        /*
         * Formato de fecha
         */
        //Sql
        $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD" 
EOD;
        //Ejecutar SQL
        CN_TABLE::executeSQL($sql);

        try {

            /*
             * Variables de filtro
             */
            //Periodo
            $id_periodo = $request['id_periodo_filtro'];
            $progress_key = $request['progress_key'] . $request['username'];

            /**
             * Consultar salario minimo
             * Se cambia a vigencia el periodo del filtro - 20140403
             * (select nvl(valor_mensual, 0) as valor_mensual from no_smdlv where vigencia = extract(year from sysdate))  
             */
            $salario_minimo = 550000;
            //Sql
            $sql = <<<EOD
(select nvl(valor_mensual, 0) as valor_mensual from no_smdlv where vigencia = (select id_anhos from no_periodo where id_periodo = $id_periodo ))  
EOD;
            //Ejecutar SQL
            $record_smlv = CN_TABLE::executeSQL($sql);

            if (count($record_smlv) > 0) {
                $salario_minimo = $record_smlv[0]['valor_mensual'];
            }

            /*
             * Obtener consultas glodal
             */
            //Sql
            $sql = <<<EOD
select * from NO_CONSULTA 
EOD;
            //Ejecutar SQL
            $record_consul = CN_TABLE::executeSQL($sql);
            $record_consulta = array();

            if (count($record_consul) > 0) {
                foreach ($record_consul as $key => $value) {
                    $record_consulta[$value['caracter']] = $value;

//                    $this->logMessage("Caracter - " . $value['caracter']);
                }
            }
//            $this->logMessage("Consulta - " . $record_consulta['M']['consulta']);
//            die();


            /**
             * Cargar tabla constantes
             */
            $text = '$con_';
            //Constantes 
            $sql = <<<EOD
Select cons.*, '$text'|| cons.id_constante as reemplazo from no_constante cons 
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);

            //Agrega a un array todas las constantes
            foreach ($records as $value) {

//                foreach ($value as $key => $value2) {
//                    $this->logMessage($key . " - " . $value2);
//                }

                $arrayConstantes[$value['reemplazo']] = $value['valor'];
//                $this->logMessage($value['reemplazo'] . "------------------------" . $arrayConstantes[$value['reemplazo']]);
            }

            /*
             * Anexo de variables del request para reemplazo en constantes
             */
            $arrayConstantes['$WDIASV'] = '0';
            $arrayConstantes['$WDIAST'] = '0';

            /*
             * Iniciar en 0 dias de liquidacion y totales de vacaciones - 20131216
             */
            $dias_liq = 0;
            $wdiasv_tot = 0;


            //Funcionario num_doc
            $num_doc = null;
            $whereFuncionarioNumDoc = "";
            if (isset($request['num_doc'])) {
                $num_doc = $request['num_doc'];
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            }
            //Funcionario id_tipo_doc 
            $id_tipo_doc = null;
            $whereFuncionarioTipoDoc = "";
            if (isset($request['id_tipo_doc'])) {
                $id_tipo_doc = $request['id_tipo_doc'];
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            }

            /*
             *  Borrar datos anteriores Periodo-Funcionario
             */
            //Sql
            $sql = <<<EOD
DELETE FROM NO_LIQUIDA_NOMINA tab0 WHERE tab0.id_periodo = $id_periodo
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
EOD;
            //Ejecutar SQL
            CN_TABLE::executeSQL($sql);

            /*
             * Tomar valores de NO_AJUSTE_NOMINA
             */
            //Sql
            $sql = <<<EOD
Insert into NO_LIQUIDA_NOMINA (ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,ID_PERIODO,VALOR_LIQUIDADO,FECHA_DESDE,FECHA_HASTA,NUM_DIAS) 

select 
tab0.id_tipo_doc,
tab0.num_doc,
tab0.id_concep_nomina,
tab0.id_periodo,
tab0.valor_ajuste,
 to_date( '01/' || per.id_meses || '/' || per.id_anhos, 'dd/mm/yyyy')  as fecha_desde,
TRUNC(LAST_DAY( to_date(per.id_meses || '/' || per.id_anhos, 'mm/yyyy')  )) as fecha_hasta,
tab0.num_dias
from no_ajuste_nomina tab0
join no_periodo per
on per.id_periodo = tab0.id_periodo 
WHERE tab0.id_periodo = $id_periodo 
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
EOD;
            //Ejecutar SQL
            CN_TABLE::executeSQL($sql);


            /**
             * se filtran para vacaciones dias de periodos adicionales - 20140613
             */
            //Sql
            $sql = <<<EOD
select 
to_char(wm_concat(id_periodo)) as  periodos
from no_periodo
where id_anhos = (select id_anhos from no_periodo where id_periodo = $id_periodo )
and id_meses = (select id_meses from no_periodo where id_periodo = $id_periodo )
and id_tipo_periodo in (1 , 2)  
EOD;
            //Ejecutar SQL
            $record_per = CN_TABLE::executeSQL($sql);
            $periodos = $record_per[0]['periodos'];


            /*
             * Cargar Periodo-Funcionario-Concepto
             * 
             * Cargar Funcionarios
             * 
             * Para cada persona
             * 
             * Cargar conceptos que apliquen en periodo para la persona, en orden de ejecución
             */
            /*
             * Se modificó la formula de liquidación de Vacaciones,  colocando la condición de Bonificación por servicios.  
             * Por lo tanto se debe verificar que el orden de concpetos para liquidación de la nómina los conceptos 1007, 1008, 1009 y 1010   
             * se liquiden despues del concpeto 1011 - 20130812
             * Se cambia calculo de dias por FECHA_RANGO_SIN_TREINTAYUNO para no tomar los dias 31 en wdiasv - 20130913
             * El orden para tomar los 4000 primero - 20140616
             */
            //Sql
            $sql = <<<EOD
select 
$salario_minimo as salario_minimo,
1 as tag,
tab0.*,
tab0.num_dias as dias_liq,
nvl(vac.dias_vac,0) as wdiasv,
tipcon.orden,
connom.codigo,
connom.usa_dias_calen
from no_concepto_periodo tab0

join no_concep_nomina connom
on connom.id_concep_nomina = tab0.id_concep_nomina

join no_tipo_concepto tipcon
on tipcon.id_tipo_concepto = connom.id_tipo_concepto
                    
left join (
    
    select 
 novvac.id_tipo_doc,                  
 novvac.num_doc,
 nvl(sum(dias_rango_mes(novvac.fecha_ini,novvac.fecha_fin,(select id_meses 
     from no_periodo where id_periodo =  $id_periodo))),0) as dias,
 nvl(sum( novvac.fecha_fin - novvac.fecha_ini + 1),0) as num_dias_vac,
 nvl(sum(FECHA_RANGO_SIN_TREINTAYUNO(novvac.fecha_ini,novvac.fecha_fin)),0) as dias_vac
 from no_novedad_vac novvac
 left join no_tipo_nov_vac tipnov on tipnov.id_tipo_nov_vac = novvac.id_tipo_nov_vac
 where tipnov.tiempo_liqui = 1 and novvac.id_periodo in ( $periodos )
 group by novvac.id_tipo_doc, novvac.num_doc
     
)vac
on vac.id_tipo_doc = tab0.id_tipo_doc and vac.num_doc = tab0.num_doc

where tab0.periodo = $id_periodo
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
and tab0.id_concep_nomina != (select id_concep_rete from no_param_concep where id_param_concep = 1)
and tipcon.id_tipo_concepto != 4
                    
order by 
tab0.id_anhos,
tab0.id_meses,
tab0.id_tipo_doc,
tab0.num_doc,
--tipcon.orden,
case 
  when connom.codigo >= 4000  
      then '0000'
  when connom.id_concep_nomina = (select no_param_concep.id_concep_bonif from no_param_concep where no_param_concep.id_param_concep = 1)  
      then '0001'
      else connom.codigo 
  end ,
tipcon.orden
--connom.codigo 
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);


            /*
             * Recorre los registros de funcionario - concepto nomina
             * para ser liquidados
             */
            $i = 1;
            $nom_conceptos_a_procesar = count($records);

            // Antes de inicar el proceso largo
            $brecha = 1;
            if ($nom_conceptos_a_procesar > 100)
                $brecha = $nom_conceptos_a_procesar - (0.99 * $nom_conceptos_a_procesar);

            $this->logMessage("[Liquidación] nom_conceptos_a_procesar: " . $nom_conceptos_a_procesar);
            $logPath = sfConfig::get('sf_log_dir') . '/liquidacion.log';
            $custom_logger = new sfFileLogger(new sfEventDispatcher(), array('file' => $logPath));
            foreach ($records as $value) {

                // Guardar un valor en el proceso largo
                if ($i % $brecha == 0) {
                    MemcacheHandler::getInstance()->set($progress_key, round(($i / $nom_conceptos_a_procesar) * 100, 0));
                }

                $this->logMessage("[Liquidación] Existen liquidaciones.");

                $id_periodo = $value['periodo'];
                $num_doc = $value['num_doc'];
                $id_tipo_doc = $value['id_tipo_doc'];
                $id_concep_nomina = $value['id_concep_nomina'];

                $custom_logger->info(MemcacheHandler::getInstance()->get($progress_key) . " - Procesado $i de $nom_conceptos_a_procesar conceptos. Funcionario: " . $num_doc . "\n");

                /*
                 * Liquidar periodo-funcionario-concepto nomina
                 */
                $this->liquidar($id_periodo, $num_doc, $id_tipo_doc, $id_concep_nomina, $value, $arrayConstantes, $record_consulta);

                // Termina procesamiento de concepto
//                file_put_contents('/home/lavila/Escritorio/liquidacion.log', "Procesado $i de $nom_conceptos_a_procesar conceptos.\n", FILE_APPEND);
                $i++;
            }
            $custom_logger->info(MemcacheHandler::getInstance()->get($progress_key) . " - Termino Mencache.\n");
            MemcacheHandler::getInstance()->set($progress_key, 99);



            /*
             * COMMIT DE TODAS LAS TRANSACCIONES
             */
            $this->conn->commit();


            /**
             * Abrir nueva conexion con la Base de Datos
             */
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();


            /**
             * Reliquidar FSP
             * Se toman conceptos segun la Tabla NO_FONDO_CONCEPTO para el id_descuento_ss = 2 
             */
            /**
             * Consultar salario minimo
             * Se cambia a vigencia el periodo del filtro - 20140403
             * (select nvl(valor_mensual, 0) as valor_mensual from no_smdlv where vigencia = extract(year from sysdate))  
             */
            $salario_minimo = 550000;
            //Sql
            $sql = <<<EOD
(select nvl(valor_mensual, 0) as valor_mensual from no_smdlv where vigencia = (select id_anhos from no_periodo where id_periodo = $id_periodo ))  
EOD;
            //Ejecutar SQL
            $record_smlv = CN_TABLE::executeSQL($sql);

            if (count($record_smlv) > 0) {
                $salario_minimo = $record_smlv[0]['valor_mensual'];
            }

            $valor_base = 0;

            /*
             * Se toman conceptos segun la 
             * Tabla NO_FONDO_CONCEPTO para el id_descuento_ss = 2 
             * Se agrega tag y periodo para la consulta de R - 20131216
             */
            $custom_logger->info(MemcacheHandler::getInstance()->get($progress_key) . " - Proceso de FSP.\n");
            //Sql
            $sql = <<<EOD
select 
$salario_minimo as salario_minimo,
1 as tag,
$id_periodo as periodo,                    
tab0.* 
from no_liquida_nomina tab0
left join no_fondo_concepto foncon
on tab0.id_concep_nomina = foncon.id_concep_nomina
where foncon.id_descuento_ss = 2
and tab0.id_periodo = $id_periodo
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
order by 
tab0.id_tipo_doc,
tab0.num_doc
EOD;

            //Ejecutar SQL
            $record_fsp = CN_TABLE::executeSQL($sql);

            $i = 0;
            $nom_conceptos_a_procesar = count($record_fsp);
            foreach ($record_fsp as $value) {

                $id_liquida_nomina = $value['id_liquida_nomina'];
                $valor_base = $value['valor_liquidado'];
                $valor_base_vac = 0;
                $num_doc = $value['num_doc'];
                $id_tipo_doc = $value['id_tipo_doc'];
                $num_dias_fsp = $value['num_dias'];
                $id_concep_nomina = $value['id_concep_nomina'];

                $custom_logger->info(MemcacheHandler::getInstance()->get($progress_key) . " - FSP - Procesado $i de $nom_conceptos_a_procesar conceptos. Funcionario: " . $num_doc . "\n");

                //Dias para vacaciones
                //Se habilita novedvac para el periodo a liquidar - filtro id_periodo - 20130722 Se deshablita - 20130723
                //Toma los dias de vacaciones para el mes a liquidar - 20130723
                //Sql
                $sql = <<<EOD
select  nvl(num_dias_vac,0) as dias_vac from (    
   select 
     novvac.id_tipo_doc,                  
     novvac.num_doc,
     nvl(sum(dias_rango_mes(novvac.fecha_ini,novvac.fecha_fin,(select id_meses 
         from no_periodo where id_periodo =  $id_periodo))),0) as dias,
     nvl(sum( novvac.fecha_fin - novvac.fecha_ini + 1),0) as dias_vac,
     nvl(sum(DIAS_RANGO_MES_SIN_TREINTAYUNO(novvac.fecha_ini,novvac.fecha_fin,(select id_meses from no_periodo where id_periodo =  $id_periodo))),0) as num_dias_vac
     from no_novedad_vac novvac
     left join NO_TIPO_NOV_VAC TIPNOV on TIPNOV.ID_TIPO_NOV_VAC = NOVVAC.ID_TIPO_NOV_VAC
     where TIPNOV.TIEMPO_LIQUI = 1 
     --and NOVVAC.ID_PERIODO = $id_periodo
     and (
             novvac.fecha_ini between to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy')
             and trunc(last_day( to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy') )) 
             or
             novvac.fecha_fin between to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy')
             and TRUNC(LAST_DAY( TO_DATE('01/'|| (select LPAD(ID_MESES,2,'0') ||'/'||ID_ANHOS from NO_PERIODO where ID_PERIODO = $id_periodo) ,'dd/mm/yyyy') )) 

             or        


             to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy') between novvac.fecha_ini and novvac.fecha_fin
             or
             trunc(last_day( to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy') )) between novvac.fecha_ini and novvac.fecha_fin
    )
     and novvac.NUM_DOC = $num_doc
     group by novvac.id_tipo_doc, novvac.num_doc
)
EOD;

                //Ejecutar SQL
                $record_vac = CN_TABLE::executeSQL($sql);
                /*
                 * Calcular IBC para vacaciones
                 */
                // Se agrega al calculo la formula (({A39}/30)*$wdiasv)) - 20130517
                // Toma los dias de vacaciones para el mes a liquidar
                $wdiasv = 0;
                if (count($record_vac) > 0) {
                    $wdiasv = $record_vac[0]['dias_vac'];
                }

                $formula = "(({A39}/30)*$wdiasv)";
                $this->logMessage("[Liquidación Vac] Formula Inicial: " . $formula);

                /*
                 * Cambio en la formula de A por (C1+C2)
                 */
                $vars = array();

                CN_TABLE::getVarsInFormula($vars, $formula);

//        var_dump($vars);

                foreach ($vars as $var) {
                    if (substr($var, 0, 1) == 'A') {
                        /*
                         * Cambio de A1 por relacion con los conceptos C1
                         * Ejemplo: 'A1' => '0'
                         */
                        $agrup = $this->reemplazoAgrupacion(substr($var, 1));
                        $this->logMessage("[Liquidación Vac] Agrupacion: " . $agrup);

                        $formula = str_replace('{' . $var . '}', $agrup, $formula);
                    }
                }
                $this->logMessage("[Liquidación Vac] Formula parametrosFormula y reemplazoAgrupacion: " . $formula);

                $arrayParametros = $this->parametrosFormula($formula);
                $arrayParametros = $this->resultadoParametros($arrayParametros, $value, $record_consulta, $vals_calc);

                $formula = $this->reemplazoParametros($formula, $arrayParametros);
                /*
                 * Ejecutar fórmula
                 * Ejemplo: ( 0 == 0 ? {C1} * $porcentaje : false )
                 * Retorna false  si no cumple con la condicion
                 */
                $formula = str_replace('{', ' ', $formula);
                $formula = str_replace('}', ' ', $formula);
                $result = CN_TABLE::aplicarEval($formula);

                /*
                 * No cumple con la condicion
                 */
//                if ($result === false) {
                if ($result == '-9999' || $result == -9999) {
                    $this->logMessage("[Liquidación Vac] Formula No cumple con la condicion: " . $formula);
                    $result = 0;
                }
                //Valor base de IBC vacaciones
                $valor_base_vac = round($result, -3);
                $this->logMessage("[Liquidación Vac] Valor base de IBC vacaciones: " . $valor_base_vac);

                /*
                 * Valor vase formula FSP
                 */
                $valor_base = round($valor_base, -3);
//                $valor_base = round($valor_base);
                //valor base no puede superar 25 salarios minimos
                if ($valor_base > ($salario_minimo * 25)) {
                    $valor_base = round(($salario_minimo * 25) - 1, -3);
//                    $valor_base = round(($salario_minimo * 25) - 1);
                }


                /*
                 * Variables del concepto 1 asignacion basica para los dias de liquidacion y totales de vacaciones - 20131216
                 * Anexo de conceptos de enfermedad por el tipo de novedad que causa liquidacion - 20131217
                 * Se agrega filtro de vacaciones para que tome novedad por la fecha y no solo el periodo - 20140526 
                 * Se quita condicion anterior - 20140605
                 * Se agregan periodos adicionales para el periodo filtrado, para que tenga en cuenta los dias de vac - 20150123 Revisar Gloria Amparo
                 */
                //Sql
                $sql = <<<EOD
select 
tab0.id_tipo_doc,
tab0.num_doc,
--tab0.id_concep_nomina,
--sum(tab0.num_dias) as dias_liq,
sum(case when connom.operador = 1 then tab0.num_dias else tab0.num_dias*(-1) end ) as dias_liq,
max(nvl(vac.dias_vac,0)) as wdiasv

from no_concepto_periodo tab0

join no_concep_nomina connom
on connom.id_concep_nomina = tab0.id_concep_nomina

join no_tipo_concepto tipcon
on tipcon.id_tipo_concepto = connom.id_tipo_concepto
                    
left join (
    
    select 
    novvac.id_tipo_doc,                  
    novvac.num_doc,
    nvl(sum(dias_rango_mes(novvac.fecha_ini,novvac.fecha_fin,(select id_meses 
        from no_periodo where id_periodo =  $id_periodo))),0) as dias,
    nvl(sum( novvac.fecha_fin - novvac.fecha_ini + 1),0) as num_dias_vac,
    nvl(sum(FECHA_RANGO_SIN_TREINTAYUNO(novvac.fecha_ini,novvac.fecha_fin)),0) as dias_vac
                        
    from no_novedad_vac novvac
    left join no_tipo_nov_vac tipnov on tipnov.id_tipo_nov_vac = novvac.id_tipo_nov_vac
    where tipnov.tiempo_liqui = 1 and novvac.id_periodo in ( $periodos )
    /*                    
    and (    
             novvac.id_periodo = $id_periodo
              or
             novvac.fecha_ini between to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy')
             and trunc(last_day( to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy') )) 
             or
             novvac.fecha_fin between to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy')
             and TRUNC(LAST_DAY( TO_DATE('01/'|| (select LPAD(ID_MESES,2,'0') ||'/'||ID_ANHOS from NO_PERIODO where ID_PERIODO = $id_periodo) ,'dd/mm/yyyy') )) 

             or        

             to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy') between novvac.fecha_ini and novvac.fecha_fin
             or
             trunc(last_day( to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy') )) between novvac.fecha_ini and novvac.fecha_fin
    )
    */
    group by novvac.id_tipo_doc, novvac.num_doc

)vac
on vac.id_tipo_doc = tab0.id_tipo_doc and vac.num_doc = tab0.num_doc

where tab0.periodo = $id_periodo
and tab0.num_doc = $num_doc
and tab0.id_tipo_doc = $id_tipo_doc

and ( 
  tab0.id_concep_nomina in (select id_concep_rein from no_concep_nomina where id_concep_nomina = (select no_param_concep.ID_CONCEP_BASICA from no_param_concep where id_param_concep = 1)) 
  or tab0.id_concep_nomina in (select id_concep_ajuste from no_concep_nomina where id_concep_nomina = (select no_param_concep.ID_CONCEP_BASICA from no_param_concep where id_param_concep = 1)) 
  or  tab0.id_concep_nomina = (select no_param_concep.ID_CONCEP_BASICA from no_param_concep where id_param_concep = 1) 
  or tab0.id_concep_nomina in (SELECT DISTINCT
    kar.ID_CONCEP_NOMINA 
    FROM NO_CONCEP_KA kar
    join NO_TIP_NOV_KA tipkar
    on tipkar.ID_TIP_NOV_KA = kar.ID_TIP_NOV_KA
    where tipkar.CAUSA_LIQUIDACION = 1) 
)
                        
and tipcon.id_tipo_concepto != 4
             
group by
tab0.id_tipo_doc,
tab0.num_doc
    --,tab0.id_concep_nomina  
EOD;
                //Ejecutar SQL
                $record_smlv = CN_TABLE::executeSQL($sql);

                if (count($record_smlv) > 0) {
                    $dias_liq = $record_smlv[0]['dias_liq'];
                    $wdiasv_tot = $record_smlv[0]['wdiasv'];
                }

                //Anexo dias totales y de vacaciones totales - 20131217
                $array_valor_base = $this->valor_base_fsp($valor_base, $salario_minimo, $valor_base_vac, $wdiasv_tot, $dias_liq, $num_doc, $id_periodo);
                $valor_fsp = $array_valor_base['valor_fsp'];
                $porcentaje_fsp = $array_valor_base['porcentaje_fsp'];

                /**
                 * SQL de consulta para validar si el concepto de FSP es por ajuste - 20131129
                 */
                //Sql
                $sql = <<<EOD
select 
tab0.id_tipo_doc,
tab0.num_doc,
tab0.id_concep_nomina,
tab0.id_periodo,
tab0.valor_ajuste,
 to_date( '01/' || per.id_meses || '/' || per.id_anhos, 'dd/mm/yyyy')  as fecha_desde,
TRUNC(LAST_DAY( to_date(per.id_meses || '/' || per.id_anhos, 'mm/yyyy')  )) as fecha_hasta,
tab0.num_dias
from no_ajuste_nomina tab0
join no_periodo per
on per.id_periodo = tab0.id_periodo 
WHERE tab0.id_periodo = $id_periodo 
and tab0.NUM_DOC = $num_doc
and tab0.id_concep_nomina = $id_concep_nomina
EOD;

                //Ejecutar SQL
                $record_fsp_ver = CN_TABLE::executeSQL($sql);

                /*
                 * Validar si el FSP es por ajuste - 20131129
                 */
                if (count($record_fsp_ver) == 0) {
                    if ($valor_fsp > 0) {

                        /*
                         * Actualizar valores de FSP
                         */
                        //sentencia sql
                        $sql = <<<EOD
update NO_LIQUIDA_NOMINA set valor_liquidado =  $valor_fsp
        , porcentaje = $porcentaje_fsp
            , valor_base = round( valor_liquidado, -3 ) 
    where id_liquida_nomina = $id_liquida_nomina 
        and id_periodo = $id_periodo
EOD;
                        //ejecuta y obtiene el resultado del sql
                        CN_TABLE::executeSQL($sql);
                    } else {

                        /*
                         * Borrar del FSP
                         */
                        //sentencia sql
                        $sql = <<<EOD
delete from NO_LIQUIDA_NOMINA where id_liquida_nomina = $id_liquida_nomina 
and id_periodo = $id_periodo
EOD;
                        //ejecuta y obtiene el resultado del sql
                        CN_TABLE::executeSQL($sql);
                    }
                } else {

                    $valor_ajuste = $record_fsp_ver[0]["valor_ajuste"];

                    /*
                     * Borrar del FSP que no estan en la tabla de ajustes - 20140515
                     */
                    //sentencia sql
                    $sql = <<<EOD
delete from NO_LIQUIDA_NOMINA where id_liquida_nomina = $id_liquida_nomina 
and id_periodo = $id_periodo
and valor_liquidado != $valor_ajuste
EOD;
                    //ejecuta y obtiene el resultado del sql
                    CN_TABLE::executeSQL($sql);
                }


                $i++;

                /*
                 * Iniciar en 0 dias de liquidacion y totales de vacaciones - 20131216
                 */
                $dias_liq = 0;
                $wdiasv_tot = 0;
            }
            $custom_logger->info(MemcacheHandler::getInstance()->get($progress_key) . " - FSP - Termino Mencache.\n");



            /*
             * COMMIT DE TODAS LAS TRANSACCIONES
             */
            $this->conn->commit();


            /**
             * Abrir nueva conexion con la Base de Datos
             */
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();



            /*
             * Inicio del proceso de calculo de Retencion en la fuente concepto 2001
             * Solo retefunte
             */
            //Sql
            $sql = <<<EOD
select 
$salario_minimo as salario_minimo,
1 as tag,
tab0.*,
tab0.num_dias as dias_liq,
tipcon.orden,
connom.codigo,
connom.usa_dias_calen
from no_concepto_periodo tab0

join no_concep_nomina connom
on connom.id_concep_nomina = tab0.id_concep_nomina

join no_tipo_concepto tipcon
on tipcon.id_tipo_concepto = connom.id_tipo_concepto

where tab0.periodo = $id_periodo
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
and tab0.id_concep_nomina = (select id_concep_rete from no_param_concep where id_param_concep = 1)
and tab0.porcentaje > 0

order by 
tab0.id_anhos,
tab0.id_meses,
tab0.id_tipo_doc,
tab0.num_doc,
tipcon.orden,
connom.codigo 
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);


            /*
             * Recorre los registros de funcionario - concepto nomina
             * para ser liquidados
             */
            $i = 0;
            $nom_conceptos_a_procesar = count($records);
            foreach ($records as $value) {
                $this->logMessage("[Liquidación] Existen liquidaciones - RETE.");

                $id_periodo = $value['periodo'];
                $num_doc = $value['num_doc'];
                $id_tipo_doc = $value['id_tipo_doc'];
                $id_concep_nomina = $value['id_concep_nomina'];

//
//                //Sql
//                $sql = <<<EOD
//select 
//* 
//from no_novedad_proced_rete
//where
//estado = 1 
//$whereFuncionarioNumDoc $whereFuncionarioTipoDoc  
//order by 
//fecha_inicial desc                     
//EOD;
//                //Ejecutar SQL
//                $record_nov = CN_TABLE::executeSQL($sql);
//
//                $id_tipo_proced_rete = 2;
//                if (count($record_nov) > 0) {
//                    $id_tipo_proced_rete = $record_nov[0]['id_tipo_proced_rete'];
//                }

                /*
                 * Validar tipo de procedimiento rete fuente
                 */
//                if ($id_tipo_proced_rete != 2) {
//
//                    /*
//                     * Liquidar proced 1(383) y reten minima(384)
//                     */
//                    $this->ejecutarFormula($formula, $arrayConstantes, $id_tipo_proced_rete);
//                } else {

                    /*
                     * Liquidar periodo-funcionario-concepto nomina
                     */
                    $this->liquidar($id_periodo, $num_doc, $id_tipo_doc, $id_concep_nomina, $value, $arrayConstantes, $record_consulta);
//                }

                // Termina procesamiento de concepto
//                file_put_contents('/home/lavila/Escritorio/liquidacion.log', "RETE - Procesado $i de $nom_conceptos_a_procesar conceptos.\n", FILE_APPEND);
//                $i++;
                $custom_logger->info(MemcacheHandler::getInstance()->get($progress_key) . " - RETE - Procesado $i de $nom_conceptos_a_procesar conceptos. Funcionario: " . $num_doc . "\n");
            }

            $custom_logger->info(MemcacheHandler::getInstance()->get($progress_key) . " - RETE - Termino Mencache.\n");
            MemcacheHandler::getInstance()->set($progress_key, 100);


            /*
             * COMMIT DE TODAS LAS TRANSACCIONES
             */
            $this->conn->commit();


            /**
             * Abrir nueva conexion con la Base de Datos
             */
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            /*
             * Validacion de tope de deducidos de no ley - 20140421
             * Valor tope = Sum Deveng por el % de max dednoley - sum dedley 
             * Se cambia Valor tope = Sum Deveng - sum dedley todo por el % de max dednoley   - 20140515
             */
            //Sql
            $sql = <<<EOD
select 

tab.id_tipo_doc, 
tab.num_doc,
tab.id_periodo,
sum(tab.valor_dev) as valor_dev,
sum(tab.VALOR_dedley) as VALOR_dedley,
sum(tab.VALOR_dednoley) as VALOR_dednoley,
sum(tab.VALOR_ded) as VALOR_ded,
max(tab.max_ded_noley) as max_ded_noley,

round( ( ( sum(tab.valor_dev) - sum(tab.VALOR_dedley) ) * max(tab.max_ded_noley) / 100 )  ) as total_tope

from (

    select 
    tab0.id_tipo_doc,
    tab0.num_doc,
    tab0.id_periodo,
    tab0.num_dias as dias, 
    tab0.id_periodo_ajuste,
    concep.codigo as codigo, 
    concep.descripcion as descripcion, 
    case when concep.id_tipo_concepto = 1 then tab0.valor_liquidado else 0 end as valor_dev, 
    case when concep.id_tipo_concepto = 2 then tab0.valor_liquidado else 0 end as VALOR_dedley, 
    case when concep.id_tipo_concepto = 3 then tab0.valor_liquidado else 0 end as VALOR_dednoley, 
    case when concep.id_tipo_concepto != 1 then tab0.valor_liquidado else 0 end as VALOR_ded,
    per.max_ded_noley
    
    FROM no_liquida_nomina tab0
    
    left join no_concep_nomina concep 
    ON concep.id_concep_nomina = tab0.id_concep_nomina
    
    join no_periodo per
    on per.id_periodo = tab0.id_periodo
    
    where 
    tab0.id_periodo = $id_periodo
    $whereFuncionarioNumDoc $whereFuncionarioTipoDoc      
    
)tab

having
sum(tab.VALOR_dednoley) > round( ( ( sum(tab.valor_dev) - sum(tab.VALOR_dedley) ) * max(tab.max_ded_noley) / 100 )  )

group by
tab.id_tipo_doc, 
tab.num_doc,
tab.id_periodo

order by tab.num_doc
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);

            $this->logMessage("[Liquidación] Existen liquidaciones - DEDNOLEY.");

            foreach ($records as $value) {

                $id_periodo = $value['id_periodo'];
                $num_doc = $value['num_doc'];
                $id_tipo_doc = $value['id_tipo_doc'];
                $total_tope = $value['total_tope'];

                $this->logMessage("[Liquidación] DEDNOLEY - Total_tope: " . $total_tope);

                /*
                 * Obtener registros de deducidos de no ley
                 * Eliminar registros que superen el tope
                 *///Sql
                $sql = <<<EOD
    select 
    tab0.id_liquida_nomina,
    tab0.id_tipo_doc,
    tab0.num_doc,
    tab0.id_periodo,
    tab0.num_dias as dias, 
    tab0.id_periodo_ajuste,
    concep.codigo as codigo, 
    concep.descripcion as descripcion, 
    tab0.valor_liquidado,
    per.max_ded_noley
    
    FROM no_liquida_nomina tab0
    
    left join no_concep_nomina concep 
    ON concep.id_concep_nomina = tab0.id_concep_nomina
    
    join no_periodo per
    on per.id_periodo = tab0.id_periodo
    
    where 
    tab0.id_periodo = $id_periodo 
    and concep.id_tipo_concepto = 3
    and tab0.num_doc = $num_doc     
    and tab0.id_tipo_doc = $id_tipo_doc 
    
    order by tab0.num_doc, concep.codigo
EOD;
                //Ejecutar SQL
                $records_ded = CN_TABLE::executeSQL($sql);

                foreach ($records_ded as $value_ded) {

                    $id_liquida_nomina = $value_ded['id_liquida_nomina'];
                    $valor_liquidado = $value_ded['valor_liquidado'];

                    if ($valor_liquidado > $total_tope) {

                        //sentencia sql
                        $sql = <<<EOD
 delete from no_liquida_nomina tab0
    where tab0.id_periodo = $id_periodo 
    and tab0.id_liquida_nomina = $id_liquida_nomina
    and tab0.num_doc = $num_doc     
    and tab0.id_tipo_doc = $id_tipo_doc 
EOD;
                        //Ejecutar SQL
                        CN_TABLE::executeSQL($sql);
                    } else {

                        $total_tope = $total_tope - $valor_liquidado;
                    }
                }
            }

            $custom_logger->info(MemcacheHandler::getInstance()->get($progress_key) . " - DEDNOLEY - Termino.\n");

            /*
             * COMMIT DE TODAS LAS TRANSACCIONES
             */
            $this->conn->commit();
            $this->status = 0;
            $this->list_data = array();
            $this->logMessage("[Liquidación] Liquidación exitosa");
        } catch (Exception $e) {
            MemcacheHandler::getInstance()->set($progress_key, 100);

            /*
             * ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
             */
            $this->conn->rollback();
            $this->status = 1;
            $this->mensajeError = "[Liquidación] Ocurrio un error: " . $e->getMessage();
            $this->list_data = array();
            $this->logMessage("[Liquidación] ERROR!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Calcular FSP aporte funcionario
     * @param type $valor_base
     * @param type $salario_minimo
     * @return int
     */
    private function valor_base_fsp($valor_base, $salario_minimo, $valor_base_vac = 0, $wdiasv = 0, $dias_liq, $num_doc, $id_periodo) {

        $this->logMessage("[Liquidación] valor_base_fsp:: valor_base: " . $valor_base . " - valor_base_vac: " . $valor_base_vac);
        $this->logMessage("[Liquidación] valor_base_fsp:: wdiasv: " . $wdiasv . " - dias_liq: " . $dias_liq);


        /*
         * WBASE=   BASE TOTAL que ya estamos hayando
         * WVRBASE=(WBASE/(WDIAST+WDIASV))*30
         * Sobre WVRBASE  verifica si debe calcular FSP y sobre ella misma ubicar el porcentaje 
         * Si aplica y tiene el porcentaje,  aplica el porcentaje sobre WBASE
         * 20131216
         */
        $valor = 0;
        $valorfps1 = 0;
        $valorfps2 = 0;
        $porcentaje = 0;
        $valor_bonif = 0;
        $valor_bonifs = 0;


        /**
         * Para las personas que tienen bonificacion por servicios se toma este valor proporcional a los dias laborados - 20140605
         */
        //Sql
        $sql = <<<EOD
select nvl(sum(valor_liquidado),0) as valor from no_liquida_nomina 
where num_doc = $num_doc and id_tipo_doc = 1 
and id_concep_nomina = (select no_param_concep.id_concep_bonif from no_param_concep where no_param_concep.id_param_concep = 1) 
and id_periodo = $id_periodo            
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        /*
         * Valida si posee el concepto
         */
        if (count($records) > 0 && $dias_liq > 0) {
            $valor_bonifs = $records[0]['valor']; //bonificacion completa
            $valor_bonif = (($valor_bonifs * $dias_liq) / 30); //bonificacion por dias laborales
        }
        $this->logMessage("[Liquidación] Valida si la persona - valor_bonif :: " . $valor_bonif);



        /*
         * Operaciones
         * Se quita la resta (- $valor_bonifs), toma el valor proporcional de los dias trabajados - 20150203 NO VA, porque el valor esta en la base por la agrupacion
         */
        $wvalor_base = (($valor_base - $valor_bonifs + $valor_bonif) / ($dias_liq + $wdiasv)) * 30;
        ///$wvalor_base = (($valor_base + $valor_bonif) / ($dias_liq + $wdiasv)) * 30;


        /**
         * Valida si la persona ingreso en el mes o se retira para tomar los dias en cuenta - 20140307
         */
        $this->logMessage("[Liquidación] Valida si la persona - wvalor_base :: " . $wvalor_base . " - Salario Minimo :: " . $salario_minimo);
        //Sql
        $sql = <<<EOD
select 
nom.* 
from no_nombramiento_v nom
where 
nom.id_tipo_doc = 1
and nom.num_doc = $num_doc
and (
nom.fecha_ingreso between (select per.fecha_ini from no_periodo per where per.id_periodo = $id_periodo) and (select per.fecha_fin from no_periodo per where per.id_periodo = $id_periodo)
or 
nom.fecha_termina between (select per.fecha_ini from no_periodo per where per.id_periodo = $id_periodo) and (select per.fecha_fin from no_periodo per where per.id_periodo = $id_periodo)
)                
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        /*
         * Valida si posee formula el concepto
         */
        if (count($records) > 0) {
            $wvalor_base = $valor_base + $valor_base_vac + $valor_bonif;
            $this->logMessage("[Liquidación] Valida si posee formula el concepto - wvalor_base :: " . $wvalor_base);
        }

        //Cambio de verificacion del valor base - 20131216
        if (($wvalor_base) > ($salario_minimo * 4) && ($wvalor_base) <= ($salario_minimo * 16)) {
            $porcentaje = 1;
        } elseif (($wvalor_base) > ($salario_minimo * 16) && ($wvalor_base) <= ($salario_minimo * 17)) {
            $porcentaje = 1.2;
        } elseif (($wvalor_base) > ($salario_minimo * 17) && ($wvalor_base) <= ($salario_minimo * 18)) {
            $porcentaje = 1.4;
        } elseif (($wvalor_base) > ($salario_minimo * 18) && ($wvalor_base) <= ($salario_minimo * 19)) {
            $porcentaje = 1.6;
        } elseif (($wvalor_base) > ($salario_minimo * 19) && ($wvalor_base) <= ($salario_minimo * 20)) {
            $porcentaje = 1.8;
        } elseif (($wvalor_base) > ($salario_minimo * 20)) {
            $porcentaje = 2;
        }

        /* INCI - 20140122
         * Patricia Montoya Falla, C.C. 35.462.698,
          Esperanza Verdugo, C.C.  46.662.659
          Yanerys Irina de la Hoz, C.C.  57.290.110
          Vladimir Yanken Cifuentes, C.C. 79.526.123
          Gustavo Pulido Casas, C.C. 93.288.443
         * 39773464
         */
        /* if ($num_doc == '35462698' || $num_doc == '46662659' || $num_doc == '57290110' || $num_doc == '79526123' || $num_doc == '93288443' || $num_doc == '51788859') {
          if (($valor_base + $valor_base_vac) > ($salario_minimo * 4) && ($valor_base + $valor_base_vac) <= ($salario_minimo * 16)) {
          $porcentaje = 1;
          } elseif (($valor_base + $valor_base_vac) > ($salario_minimo * 16) && ($valor_base + $valor_base_vac) <= ($salario_minimo * 17)) {
          $porcentaje = 1.2;
          } elseif (($valor_base + $valor_base_vac) > ($salario_minimo * 17) && ($valor_base + $valor_base_vac) <= ($salario_minimo * 18)) {
          $porcentaje = 1.4;
          } elseif (($valor_base + $valor_base_vac) > ($salario_minimo * 18) && ($valor_base + $valor_base_vac) <= ($salario_minimo * 19)) {
          $porcentaje = 1.6;
          } elseif (($valor_base + $valor_base_vac) > ($salario_minimo * 19) && ($valor_base + $valor_base_vac) <= ($salario_minimo * 20)) {
          $porcentaje = 1.8;
          } elseif (($valor_base + $valor_base_vac) > ($salario_minimo * 20)) {
          $porcentaje = 2;
          }
          }
          //num_doc in (13507148, 51653492 ,79250331 ,52779827 ,20404209)
          if ($num_doc == '51653492' || $num_doc == '79250331') {
          $porcentaje = 0;
          }
         */
        /**
         * Se redondea valor al sumar al final y no $valorfps1 / $valorfps2, por separado  - 20140616
         */
        $this->logMessage("[Liquidación] valor_base_fsp:: valor_base: " . $valor_base);
//        $valorfps1 = round($valor_base * 0.5 / 100, -2);
//        $valorfps2 = round($valor_base * ($porcentaje - 0.5) / 100, -2);
        $valorfps1 = $valor_base * 0.5 / 100;
        $valorfps2 = $valor_base * ($porcentaje - 0.5) / 100;
        $this->logMessage("[Liquidación] valor_base_fsp:: valorfps1: " . $valorfps1 . " - valorfps2: " . $valorfps2);

        //se cambia el redondeo al sumar valores como esta en autoliquidacion
//        $valor = round(($valorfps1 + $valorfps2) - 1, -2);
        $valor = CN_TABLE::redondeoValor($valorfps1, -2) + CN_TABLE::redondeoValor($valorfps2, -2);

        $array_fsp = array(
            'valor_fsp' => $valor,
            'porcentaje_fsp' => $porcentaje
        );

        return $array_fsp;
    }

    /**
     * Procesa la liquidacion para el periodo, funcionario y concepto nomina
     * @param type $id_periodo
     * @param type $num_doc
     * @param type $id_tipo_doc
     * @param type $id_concep_nomina
     * @param type $record_liq
     * @param type $arrayConstantes
     */
    private function liquidar($id_periodo, $num_doc, $id_tipo_doc, $id_concep_nomina, $record_liq, $arrayConstantes, $record_consulta) {
        $this->logMessage("[Liquidación] Liquidar: periodo " . $id_periodo .
                " - funcionario " . $num_doc . " - concepto nomina " . $id_concep_nomina);

        /**
         * Varibles
         */
        $arrayParametros = array();
        /*
         * Variable para optimizar consultas de formulas en las liquidaciones - 20140117
         */
        $vals_calc = array();
        $valor_liquidado = 0;
        $fecha_desde = $record_liq['fecha_desde'];
        $fecha_hasta = $record_liq['fecha_hasta'];
        $num_dias = $record_liq['num_dias'];

        //Concepto Nomina 1009 Vacaciones
        if ($id_concep_nomina == 9) {
            $record_liq['vig_ini'] = $record_liq['id_anhos'];
            $record_liq['per_ini'] = 1;
            $record_liq['vig_fin'] = $record_liq['id_anhos'];
            $record_liq['per_fin'] = $record_liq['id_meses'];
        }

        /*
         * Valor Base y porcentaje
         */
        $porcentaje = 'null';
        $valor_base = 'null';

        /*
         * Cargar fórmulas por concepto
         * Se modifico formula Para aporte en salud, pensión y FSP  existe un tope máximo de aporte de 25 SMLV
         * se toma del id_concep_nomina asociado al descuento - 20130814
         */
        //Sql
        $sql = <<<EOD
select distinct * from no_formula 
   WHERE id_concep_nomina =   (    
   
  select distinct 
  nvl( id_concep_nomina_ss, ID_CONCEP_NOMINA) as ID_CONCEP_NOMINA 
  from
  (
  
      select 
      formula.ID_FORMULA,
      formula.ID_CONCEP_NOMINA,
      formula.FORMULA,
      formula.NOMBRE,
      formula.COD_TIPO,
      foncon.id_descuento_ss,
      des.id_concep_nomina as id_concep_nomina_ss
      from no_formula formula
      left join no_fondo_concepto foncon
      on formula.id_concep_nomina = foncon.id_concep_nomina
      left join no_descuento_ss des
      on foncon.id_descuento_ss = des.id_descuento_ss
      where formula.id_concep_nomina = $id_concep_nomina 
  
  )

)   
EOD;

        /*
         * Variables y estructura para manejo de consultas con variables bind - 20130829
         */
//        $record_var_bind = array(
//            'id_concep_nomina' => 'id_concep_nomina'
//        );
//        $record_bind = array(
//            'id_concep_nomina' => $id_concep_nomina
//        );
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);
//        $records = CN_TABLE::executeBindSQL($sql, null, $record_var_bind, $record_bind);

        /*
         * Valida si posee formula el concepto
         */
        if (count($records) > 0) {
            $this->logMessage("[Liquidación] Entro a calcular Formula.");

            foreach ($records as $value) {

                $formula = $value['formula'];
                $this->logMessage("[Liquidación] Formula Inicial: " . $formula);


                /*
                 *  Buscar las constantes, variables, fórmulas(parametros) y agrupaciones que use la fórmula
                 */
                //Reemplazo de constantes            
                $formula = $this->reemplazoConstante($formula, $arrayConstantes);
                $this->logMessage("[Liquidación] Formula Constante: " . $formula);

                /*
                 * Reemplaza en la consulta los filtros y valores del SQL, que vienen en el record
                 * Ejemplo: select raz_soc from id_cia where id_cia = $id_cia
                 * Reemplaza $id_cia por el valor en el record
                 */
                $formula = CN_TABLE::reemplazoConsulta($formula, $record_liq);
                $this->logMessage("[Liquidación] Formula consulta los filtros: " . $formula);

                /*
                 * Cambio en la formula de A por (C1+C2)
                 */
                $vars = array();

                CN_TABLE::getVarsInFormula($vars, $formula);

//        var_dump($vars);

                foreach ($vars as $var) {
                    if (substr($var, 0, 1) == 'A') {
                        /*
                         * Cambio de A1 por relacion con los conceptos C1
                         * Ejemplo: 'A1' => '0'
                         */
                        $this->logMessage("[Liquidación] vals_calc: " . $var);
                        if (!isset($vals_calc[$var])) {
                            $formula_agrup = $this->reemplazoAgrupacion(substr($var, 1));
                            $this->logMessage("[$var] [Liquidación Agrupación] Agrupacion: " . $formula_agrup);

                            // $formula = str_replace('{' . $var . '}', $agrup, $formula);
                            $params_agrup = $this->parametrosFormula($formula_agrup);
                            $res_agrup = $this->resultadoParametros($params_agrup, $record_liq, $record_consulta, $vals_calc);
                            $formula_agrup = $this->reemplazoParametros($formula_agrup, $res_agrup);

                            $formula_agrup = str_replace('{', ' ', $formula_agrup);
                            $formula_agrup = str_replace('}', ' ', $formula_agrup);
                            $result_agrup = CN_TABLE::aplicarEval($formula_agrup);

                            /*
                             * No cumple con la condicion
                             */
                            //                if ($result === false) {
                            if ($result_agrup == '-9999' || $result_agrup == -9999) {
                                $this->logMessage("[$var] [Liquidación Agrupación] Formula No cumple con la condicion: " . $formula_agrup);
                                $result_agrup = 0;
                            }

                            $vals_calc[$var] = $result_agrup;
                        }

                        $formula = str_replace('{' . $var . '}', $vals_calc[$var], $formula);
                    }
                }
                $this->logMessage("[Liquidación] Formula parametrosFormula y reemplazoAgrupacion: " . $formula);


                /*
                 * Parser de la formula para obtener parametros(variables)
                 * Ejemplo: 'A1' => '0',
                 * 'C1' => '0'
                 */
                $arrayParametros = $this->parametrosFormula($formula);


                /*
                 * Obtener resultados de los parametros(variables)
                 * Ejemplo: $arrayParametros = array(
                 * 'C1' => '0',
                 * 'C2' => '0'
                 * );
                 */
                $arrayParametros2 = $this->resultadoParametros($arrayParametros, $record_liq, $record_consulta, $vals_calc);


                /*
                 * Reemplazo de parametros(variables) a la formula
                 * Ejemplo: $arrayParametros = array(
                 * 'C1' => '1100',
                 * 'C2' => '55'
                 * );
                 */
                $formula = $this->reemplazoParametros($formula, $arrayParametros2);
                $this->logMessage("[Liquidación] Formula Final: " . $formula);


                /*
                 * Ejecutar fórmula
                 * Ejemplo: ( 0 == 0 ? {C1} * $porcentaje : false )
                 * Retorna false  si no cumple con la condicion
                 */
                $formula = str_replace('{', ' ', $formula);
                $formula = str_replace('}', ' ', $formula);
                $result = CN_TABLE::aplicarEval($formula);


                /*
                 * No cumple con la condicion
                 */
                if ($result === false) {
                    $this->logMessage("[Liquidación] Formula No cumple con la condicion: " . $formula);
                    $result = 0;
                }


                /*
                 * Acumulan resultados de liquidacion
                 */
                if ($result !== -9999) // Validar al cumplir condicion -9999 - no cumplue con la condicion de la formula
                    $valor_liquidado += $result;

                /*
                 * Si es por porcentaje
                 */
                if ($record_liq['porcentaje'] != '' || $record_liq['porcentaje'] != null) {
                    /*
                     * Tipo de formula
                     * V - Valor base 
                     * R - Valor restado 
                     * F - Valor de la fórmula (Uso normal)
                     */
                    $porcentaje = $record_liq['porcentaje'];
                    if ($value['cod_tipo'] == 'V') {
                        $this->logMessage("[Liquidación] Formula CodTipo: " . $value['cod_tipo']);

                        /*
                         * Valor Base y porcentaje
                         */
                        $valor_base = ($result * 100) / $record_liq['porcentaje'];
                    }
                }
            }
        } else {

            /*
             * La liquidación se hacer por 2 espacios temporales:
             *
             * - Mensual
             * En cuyo caso, todos los meses tienen una duración de 30 días
             * - Por días calendario
             * En cuyo caso se hace por la cantidad de días especificada en no_concepto_periodo.num_dias
             * 
             * Esta especificación, si se hace mensual o usando los días, lo especifica la variable no_concep_nomina.dias_calendario
             * 
             * Si se hace una interrupción en un concepto, digamos algún cargo temporal, debe liquidarse el valor del concepto asÍ: 
             * Ejemplo: $valor = ($valor_liquidado_concepto_mes/30)*$num_dias
             */

            /*
             * Si es por porcentaje y diferente de 0
             */
            if (($record_liq['porcentaje'] != '' || $record_liq['porcentaje'] != null) && $record_liq['porcentaje'] != 0) {
                $this->logMessage("[Liquidación] Calcular porcentaje - " . $record_liq['porcentaje']);


                //Sql
                $sql = <<<EOD
select * from no_liquida_nomina 
where id_concep_nomina = (select id_concep_basica from no_param_concep where id_param_concep = 1)
and id_periodo = $id_periodo
and id_tipo_doc = $id_tipo_doc
and num_doc = '$num_doc' 
EOD;
                //Ejecutar SQL
                $records = CN_TABLE::executeSQL($sql);

                if (count($records) <= 0) {
                    $records[0]['valor_liquidado'] = 0;
                }

                //Resultado del calculo de porcentaje
                $result = ($records[0]['valor_liquidado'] * $record_liq['porcentaje']) / 100;

                /*
                 * Valor Base y porcentaje
                 */
                $porcentaje = $record_liq['porcentaje'];
                $valor_base = $records[0]['valor_liquidado'];
            } else {
                $this->logMessage("[Liquidación] Calcular valor - " . $record_liq['valor']);

                if (!is_null($record_liq['num_dias'])) {

                    /*
                     * usa_dias_calen
                     */
                    if ($record_liq['usa_dias_calen'] == 0) { //Mensual
                        $num_dias = 30;
                        $num_dias = $record_liq['num_dias']; // ? Revisar
                    } else { //Por días calendario
                        $num_dias = $record_liq['num_dias'];
                    }

                    $result = ($record_liq['valor'] / 30) * $num_dias;
                } else {
                    $num_dias = 'null';
                    $result = $record_liq['valor'];
                }
            }

            $valor_liquidado += $result;
        }

        /*
         * Valida creacion de registro
         */
        $this->logMessage("[Liquidación] Valor de liquidacion = " . $valor_liquidado);
        if ($valor_liquidado > 0) {

            $this->logMessage("[Liquidación] El valor liquidado es: " . $valor_liquidado);


            /**
             * SGC: Valida si es retefuente y redondea al mil - 20140320
             */
            $id_concep_nomina_rete = 0;

            //Sql para tomar id de retefuente
            $sql = <<<EOD
select * from no_param_concep where id_param_concep = 1
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);

            if (count($records) > 0) {
                $id_concep_nomina_rete = $records[0]['id_concep_rete'];
            }
            //SGC: Valida si es retefuente y redondea al mil - 20140320
            if ($id_concep_nomina == $id_concep_nomina_rete) {
                $valor_liquidado = round($valor_liquidado, -3);
            }


            /*
             * Crear nueva liquidación
             * 
             * Asignar valores encontrados en persona
             */
            //insert into no_liquida_nomina (id_liquida_nomina,id_tipo_doc,num_doc,id_concep_nomina,
            //id_periodo,valor_liquidado,fecha_desde,fecha_hasta,num_dias) 
            //values ('9','1','17304849','1','13','257100',to_date('22/11/12','DD/MM/RR'),
            //to_date('22/11/12','DD/MM/RR'),'30');
            //Sql
            $sql = <<<EOD
insert into no_liquida_nomina (id_tipo_doc, num_doc, id_concep_nomina,
        id_periodo,valor_liquidado,fecha_desde,fecha_hasta,num_dias, valor_base, porcentaje ) 
        values ( $id_tipo_doc, '$num_doc', $id_concep_nomina, $id_periodo, round( $valor_liquidado, 0), 
        to_date('$fecha_desde','YYYY-MM-DD'), to_date('$fecha_hasta','YYYY-MM-DD'), $num_dias, round( $valor_base, 0), $porcentaje ) 
EOD;
            /*
             * Variables y estructura para manejo de consultas con variables bind - 20130829
             */
            /*
             * insert into no_liquida_nomina (id_tipo_doc, num_doc, id_concep_nomina,
              id_periodo,valor_liquidado,fecha_desde,fecha_hasta,num_dias, valor_base, porcentaje )
              values ( :id_tipo_doc, :num_doc, :id_concep_nomina, :id_periodo, round( :valor_liquidado, 0),
              to_date(:fecha_desde,'YYYY-MM-DD'), to_date(:fecha_hasta,'YYYY-MM-DD'), :num_dias, round( :valor_base, 0), :porcentaje )
             */
//            $record_var_bind = array(
//                'id_tipo_doc' => 'id_tipo_doc',
//                'num_doc' => 'num_doc',
//                'id_concep_nomina' => 'id_concep_nomina',
//                'id_periodo' => 'id_periodo',
//                'valor_liquidado' => 'valor_liquidado',
//                'fecha_desde' => 'fecha_desde',
//                'fecha_hasta' => 'fecha_hasta',
//                'num_dias' => 'num_dias',
//                'valor_base' => 'valor_base',
//                'porcentaje' => 'porcentaje'
//            );
//            $record_bind = array(
//                'id_tipo_doc' => $id_tipo_doc,
//                'num_doc' => $num_doc,
//                'id_concep_nomina' => $id_concep_nomina,
//                'id_periodo' => $id_periodo,
//                'valor_liquidado' => $valor_liquidado,
//                'fecha_desde' => $fecha_desde,
//                'fecha_hasta' => $fecha_hasta,
//                'num_dias' => $num_dias,
//                'valor_base' => $valor_base,
//                'porcentaje' => $porcentaje
//            );
            //Ejecutar SQL
            CN_TABLE::executeSQL($sql);
//            CN_TABLE::executeBindSQL($sql, null, $record_var_bind, $record_bind);
        }
        //Valida si es retefuente y el valor es negativo - 20130724
        elseif ($valor_liquidado < 0) {
            $this->logMessage("[Liquidación] El valor_liquidado es menor a cero.");

            $id_concep_nomina_rete = 0;

            //Sql para tomar id de retefuente
            $sql = <<<EOD
select * from no_param_concep where id_param_concep = 1
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);

            if (count($records) > 0) {
                $id_concep_nomina_rete = $records[0]['id_concep_rete'];
            }
            //Valida si es retefuente y los dias mayores a cero
            if ($id_concep_nomina == $id_concep_nomina_rete && $num_dias > 0) {

                $this->logMessage("[Liquidación] Valida si es retefuente y el valor es negativo.");

                /*
                 * Crear nueva liquidación
                 * 
                 * Asignar valores encontrados en persona
                 */
                $valor_liquidado = $valor_liquidado * (-1);

                //Sql
                $sql = <<<EOD
insert into no_liquida_nomina (id_tipo_doc, num_doc, id_concep_nomina,
        id_periodo,valor_liquidado,fecha_desde,fecha_hasta,num_dias, valor_base, porcentaje ) 
        values ( $id_tipo_doc, '$num_doc', 
                    (select case when tab0.id_concep_rein is null then tab0.id_concep_nomina 
    else tab0.id_concep_rein end as id_concep_nomina
from no_concep_nomina tab0    
where tab0.id_concep_nomina = $id_concep_nomina)
                        , $id_periodo, round( $valor_liquidado, 0), 
        to_date('$fecha_desde','YYYY-MM-DD'), to_date('$fecha_hasta','YYYY-MM-DD'), $num_dias, round( $valor_base, 0), $porcentaje ) 
EOD;
                //Ejecutar SQL
                CN_TABLE::executeSQL($sql);
            } else {
                $this->logMessage("[Liquidación] No es retefuente. Valores- " . $id_concep_nomina_rete . " - " . $id_concep_nomina);
            }
        } else {

            $this->logMessage("[Liquidación] El valor_liquidado es cero.");
        }

//        $logPath = sfConfig::get('sf_log_dir') . '/liquidacion.log';
//        $custom_logger = new sfFileLogger(new sfEventDispatcher(), array('file' => $logPath));
//        $custom_logger->info("[Liquidación] memory_get_usage pre liquidar: " . CN_TABLE::convert(memory_get_usage()) . "\n");
//        unset($records, $record_var_bind, $record_bind, $record_liq, $record_consulta);
//        $custom_logger->info("[Liquidación] memory_get_usage post liquidar: " . CN_TABLE::convert(memory_get_usage()) . "\n");
    }

    /**
     * Reemplaza en la formula las constantes por valores de la tabla NO_CONSTANTE
     * Ejemplo: $con_1
     * @param type $formula
     * @param type $arrayConstantes
     */
    private function reemplazoConstante($formula, $arrayConstantes) {

        /*
         * Recorrer array de Constantes
         */
        foreach ($arrayConstantes as $key => $value) {

            //$formula = str_replace($key, $value['valor'], $formula);
            $formula = str_replace($key, $value, $formula);
        }

        return $formula;
    }

    /**
     * Reemplaza los parametros(variables) a la formula
     * Ejemplo: $key: {C1} / $value: valor - 2+5
     * @param type $formula
     * @param type $arrayParametros
     */
    private function reemplazoParametros($formula, $arrayParametros) {

        /*
         * Recorrer array de Parametros
         */
        foreach ($arrayParametros as $key => $value) {

            $formula = str_replace('{' . $key . '}', $value, $formula);
        }

        return $formula;
    }

    /**
     * Obtener resultados de los parametros(variables)
     * Ejemplo: 'C1' => '0'
     * @param type $arrayParametros
     * @param type $record_liq
     */
    private function resultadoParametros($arrayParametros, $record_liq, $record_consulta, $vals_calc) {

//        $logPath = sfConfig::get('sf_log_dir') . '/liquidacion.log';
//        $custom_logger = new sfFileLogger(new sfEventDispatcher(), array('file' => $logPath));
//
//        $custom_logger->info("[Liquidación] memory_get_usage ini resultadoParametros: " . CN_TABLE::convert(memory_get_usage()) . "\n");
        /*
         * Recorrer array de Parametros
         */
        foreach ($arrayParametros as $key => $value) {

            //Sacar caracter y numero(id_concep_nomina) para consulta
            $caracter = substr($key, 0, 1);
            $id_concep_nomina = substr($key, 1);
            $this->logMessage("[Liquidación] Caracter: " . $caracter . ", numero: " . $id_concep_nomina);

            /*
             * Obtener consulta por caracter
             */
//            //Sql
//            $sql = <<<EOD
//select * from NO_CONSULTA where caracter = '$caracter' 
//EOD;
//            //Ejecutar SQL
//            $record = CN_TABLE::executeSQL($sql);
            //Validar registros SQL
            if (count($record_consulta) > 0) {
//                $this->logMessage("[Liquidación] Caracter: " . $record_consulta[$caracter]['caracter'] . ", consulta: " . $record_consulta[$caracter]['consulta']);
//                die();
//                $consulta = $record[0]['consulta'];

                $this->logMessage("[Liquidación] Concat vals_calc: " . $caracter . $id_concep_nomina);
                if (!isset($vals_calc[$caracter . $id_concep_nomina])) {
                    $consulta = $record_consulta[$caracter]['consulta'];

                    /*
                     * Variables y estructura para manejo de consultas con variables bind - 20130829
                     */
                    //Reemplazo de $ por : para variables bind
//                $consulta = str_replace('$', ':', $consulta);
                    //Reemplazo de id_concep_nomina
                    $consulta = str_replace('$id_concep_nomina', $id_concep_nomina, $consulta);

                    /*
                     * Reemplaza en la consulta los filtros y valores del SQL, que vienen en el record
                     * Ejemplo: select raz_soc from id_cia where id_cia = $id_cia
                     * Reemplaza $id_cia por el valor en el record
                     */
                    $consulta = CN_TABLE::reemplazoConsulta($consulta, $record_liq);

                    /*
                     * Ejecutar SQL de consulta
                     * select nvl(sum(valor_liquidado),0) as valor from no_liquida_nomina where id_periodo = :periodo - ejemplo bind
                     */
                    //Sql
                    $sql = <<<EOD
$consulta  
EOD;
                    /*
                     * Variables y estructura para manejo de consultas con variables bind - 20130829
                     */
//                $record_var_bind = array(
//                    'id_tipo_doc' => 'id_tipo_doc',
//                    'num_doc' => 'num_doc',
//                    'id_concep_nomina' => 'id_concep_nomina',
//                    'id_periodo' => 'id_periodo'
//                );
                    //Get the variables within the consulta
//        $custom_logger->info("[Liquidación] memory_get_usage 1 resultadoParametros: " . CN_TABLE::convert(memory_get_usage()) . "\n");
//                $vars = array();
//                CN_TABLE::getVarsInConsulta($vars, $sql);
//                $record_var_bind = $vars;
////                var_dump($record_var_bind);
//                $record_bind = $record_liq;
//                $record_bind['id_concep_nomina'] = $id_concep_nomina;
                    //Ejecutar SQL
                    $record = CN_TABLE::executeSQL($sql);
//                $sql = str_replace("'", null, $sql);
//                $custom_logger->info("[Liquidación] memory_get_usage 2 resultadoParametros: " . CN_TABLE::convert(memory_get_usage()) . "\n");
//                $record = CN_TABLE::executeBindSQL($sql, null, $record_var_bind, $record_bind);
//                $custom_logger->info("[Liquidación] memory_get_usage 3 resultadoParametros: " . CN_TABLE::convert(memory_get_usage()) . "\n");
                    /*
                     * Validar registros SQL
                     */
                    if (count($record) > 0) {
                        $valor = $record[0]['valor'];
                    } else {
                        $valor = 0;
                    }
                    $vals_calc[$caracter . $id_concep_nomina] = $valor;
                }
                $valor = $vals_calc[$caracter . $id_concep_nomina];
            } else {
                $valor = 0;
            }

            $arrayParametros[$key] = $valor;

            $this->logMessage("[Liquidación] Valor por Caracter: " . $valor);
        }
        //Destruye una variable especificada
//        $custom_logger->info("[Liquidación] memory_get_usage pre resultadoParametros: " . CN_TABLE::convert(memory_get_usage()) . "\n");
//        unset($vars, $record_var_bind, $record_bind, $record_liq, $record, $key, $sql, $valor, $record_consulta, $consulta, $caracter);
//        $custom_logger->info("[Liquidación] memory_get_usage post resultadoParametros: " . CN_TABLE::convert(memory_get_usage()) . "\n");
        return $arrayParametros;
    }

    /**
     * Parser de la formula para obtener parametros(variables)
     * Ejemplo: 'C1' => '0'
     * @param type $formula
     * @param type $arrayParametros
     */
    private function parametrosFormula($formula) {

        $vars = array();
        $arrayParametros = array();
        CN_TABLE::getVarsInFormula($vars, $formula);

        foreach ($vars as $var) {
            $arrayParametros[$var] = 0;
        }

//        var_dump($arrayParametros);
//        exit();
//        $arrayParametros = array(
//            'C1' => '0',
//            'C2' => '0',
//            'T1' => '0',
//            'A1' => '0'
//        );

        return $arrayParametros;
    }

    /**
     * Reemplaza las agrupaciones por los parametros(variables)
     * Ejemplo: A1 -> (+C1-C2-T1)
     * @param type $id_agrup_var
     */
    private function reemplazoAgrupacion($id_agrup_var) {

        $agrup = '( ';

        /*
         * Ejecutar SQL de agrupciones
         */
        //Sql
        $sql = <<<EOD
select 
agru.*,
agru.tipo_valor as caracter
from
no_agrup_deta agru
where agru.id_agrup_concepto = $id_agrup_var  
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        /*
         * Recorrer registros 
         */
        foreach ($records as $value) {

            $operador = ($value['operador'] == 1 ? '+' : '-');

            //Concatenar todas las agrupaciones
            $agrup .= $operador . '{' . $value['caracter'] . $value['id_concep_nomina'] . '}';
        }

        $agrup .= ' )';

        return $agrup;
    }

    /**
     * Ejecutar formula
     * 
     * @param type $formula
     * @param type $arrayConstantes
     * @param int $record_liq
     * @return int
     */
    public function ejecutarFormula($formula, $arrayConstantes, $record_liq) {

        $this->logMessage("[Liquidación] Entro a calcular Formula.");


        $this->logMessage("[Liquidación] Formula Inicial: " . $formula);


        /*
         *  Buscar las constantes, variables, fórmulas(parametros) y agrupaciones que use la fórmula
         */
        //Reemplazo de constantes            
        $formula = $this->reemplazoConstante($formula, $arrayConstantes);
        $this->logMessage("[Liquidación] Formula Constante: " . $formula);

        /*
         * Reemplaza en la consulta los filtros y valores del SQL, que vienen en el record
         * Ejemplo: select raz_soc from id_cia where id_cia = $id_cia
         * Reemplaza $id_cia por el valor en el record
         */
        if ($record_liq['porcentaje'] == '' || $record_liq['porcentaje'] == null) {
            $record_liq['porcentaje'] = 0;
        }
        $formula = CN_TABLE::reemplazoConsulta($formula, $record_liq);
        $this->logMessage("[Liquidación] Formula consulta los filtros: " . $formula);

        /*
         * Cambio en la formula de A por (C1+C2)
         */
        $vars = array();

        CN_TABLE::getVarsInFormula($vars, $formula);

//        var_dump($vars);

        foreach ($vars as $var) {
            if (substr($var, 0, 1) == 'A') {
                /*
                 * Cambio de A1 por relacion con los conceptos C1
                 * Ejemplo: 'A1' => '0'
                 */
                $agrup = $this->reemplazoAgrupacion(substr($var, 1));
                $this->logMessage("[Liquidación] Agrupacion: " . $agrup);

                $formula = str_replace('{' . $var . '}', $agrup, $formula);
            }
        }
        $this->logMessage("[Liquidación] Formula parametrosFormula y reemplazoAgrupacion: " . $formula);


        /*
         * Parser de la formula para obtener parametros(variables)
         * Ejemplo: 'A1' => '0',
         * 'C1' => '0'
         */
        $arrayParametros = $this->parametrosFormula($formula);


        /*
         * Obtener resultados de los parametros(variables)
         * Ejemplo: $arrayParametros = array(
         * 'C1' => '0',
         * 'C2' => '0'
         * );
         */
        $arrayParametros = $this->resultadoParametros($arrayParametros, $record_liq);


        /*
         * Reemplazo de parametros(variables) a la formula
         * Ejemplo: $arrayParametros = array(
         * 'C1' => '1100',
         * 'C2' => '55'
         * );
         */
        $formula = $this->reemplazoParametros($formula, $arrayParametros);
        $this->logMessage("[Liquidación] Formula Final: " . $formula);


        /*
         * Ejecutar fórmula
         * Ejemplo: ( 0 == 0 ? {C1} * $porcentaje : false )
         * Retorna false  si no cumple con la condicion
         */
        $formula = str_replace('{', ' ', $formula);
        $formula = str_replace('}', ' ', $formula);
        $result = CN_TABLE::aplicarEval($formula);


        /*
         * No cumple con la condicion
         */
//                if ($result === false) {
        if ($result == '-9999' || $result == -9999) {
            $this->logMessage("[Liquidación] Formula No cumple con la condicion: " . $formula);
            $result = 0;
        }


        /*
         * Acumulan resultados de liquidacion
         */
        $valor_liquidado = $result;

        return $valor_liquidado;
    }

}
